package esercizio1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;

public class Concessionaria {
	
	private ArrayList<Veicolo> veicoli;
	
	public Concessionaria() {
		veicoli = new ArrayList<Veicolo>();
	}
	
	public void aggiungiVeicolo(Veicolo v) {
		veicoli.add(v);
	}
	
	public void rimuoviVeicolo(Veicolo v) {
		veicoli.remove(v);
	}
	
	public void stampaVeicoli() {
		System.out.println(veicoli);
	}
	
	public void ordinaVeicoliPerPrezzo() {
		veicoli.sort(new Comparator<Veicolo>() {
			@Override
			public int compare(Veicolo o1, Veicolo o2) {
				return o1.getPrezzo().compareTo(o2.getPrezzo());
			}
		});
	}
	
	public void ordinaVeicoliPerNome() {
		veicoli.sort(new Comparator<Veicolo>() {

			@Override
			public int compare(Veicolo o1, Veicolo o2) {
				return o1.getNome().compareTo(o2.getNome());
			}
		});
	}
	
	public Double calcolaValore() {
		Double somma = 0.0;
		for(Veicolo v : veicoli) {
			somma += v.getPrezzo();
		}
		return somma;
	}
	
	public void salvaSuFile(String filename) throws IOException {
		BufferedWriter bw = new BufferedWriter(new FileWriter(filename));
		for(Veicolo v : veicoli) {
			bw.append(v.getStringForFile());
			bw.newLine();
		}
		bw.close();
	}
	
	public void leggiDaFile(String filename) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		while(br.ready()) {
			String line = br.readLine();
			String[] info = line.split(";");
			Veicolo v;
			if(info[0].equals("veicolo"))
			  v = new Veicolo(info[1], info[2], info[3], Double.parseDouble(info[4]));
			else if(info[0].equals("automobile"))
			  v = new Automobile(info[1], info[2], info[3], Double.parseDouble(info[4]));
			else
			  v = new Moto(info[1], info[2], info[3], Double.parseDouble(info[4]));
			aggiungiVeicolo(v);
		}
		br.close();
	}
}
