package net.alviano.safe;

import static org.apache.commons.lang3.Validate.inclusiveBetween;

public final class AliquotaSconto {
	private final int millesimi;
	
	public AliquotaSconto(int millesimi) {
		inclusiveBetween(0, 1000, millesimi);
		this.millesimi = millesimi;
	}
	
	public int millesimi() {
		return millesimi;
	}
	
	@Override
	public String toString() {
		return String.format("$d.$3d", millesimi / 1000, millesimi % 1000);
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != AliquotaSconto.class) return false;
		AliquotaSconto a = (AliquotaSconto) o;
		return this.millesimi == a.millesimi;
	}
}
