package net.alviano.safe;

import static org.apache.commons.lang3.Validate.*;

public final class Automobile extends Veicolo {
	public Automobile(Targa targa, CasaProduttrice casaProduttrice, ModelloVeicolo modello, Prezzo prezzo) {
		super(notNull(targa), notNull(casaProduttrice), notNull(modello), notNull(prezzo));
	}
	
	@Override
	public Prezzo prezzoFinale() {
		if(prezzo().compareTo(new Prezzo(10000)) < 0) return prezzo().scontato(new AliquotaSconto(50));
		if(prezzo().compareTo(new Prezzo(20000)) < 0) return prezzo().scontato(new AliquotaSconto(100));
		return prezzo();
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != Automobile.class) return false;
		Automobile a = (Automobile) o;
		return this.targa().equals(a.targa()) && this.casaProduttrice().equals(a.casaProduttrice()) && this.modello().equals(a.modello()) && this.prezzo().equals(a.prezzo());
	}
	
}
