package net.alviano.safe;

import static org.apache.commons.lang3.Validate.inclusiveBetween;
import static org.apache.commons.lang3.Validate.matchesPattern;
import static org.apache.commons.lang3.Validate.notBlank;

public final class CasaProduttrice {
	private final String value;
	
	public CasaProduttrice(String value) {
		this.value = notBlank(value);
		inclusiveBetween(2, 100, value.length());
		matchesPattern(value, "[0-9A-Za-z -]*");
		// altra validazione
	}
	
	public String value() {
		return this.value;
	}
	
	@Override
	public String toString() {
		return value;
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != CasaProduttrice.class) return false;
		CasaProduttrice c = (CasaProduttrice) o;
		return this.value.equals(c.value);
	}

}
