package net.alviano.safe;

import static org.apache.commons.lang3.Validate.*;

public final class Moto extends Veicolo {
	public Moto(Targa targa, CasaProduttrice casaProduttrice, ModelloVeicolo modello, Prezzo prezzo) {
		super(notNull(targa), notNull(casaProduttrice), notNull(modello), notNull(prezzo));
	}
	
	@Override
	public Prezzo prezzoFinale() {
		if(prezzo().compareTo(new Prezzo(7000)) < 0) return prezzo().scontato(new AliquotaSconto(30));
		if(prezzo().compareTo(new Prezzo(15000)) < 0) return prezzo().scontato(new AliquotaSconto(75));
		return prezzo();
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != Moto.class) return false;
		Moto m = (Moto) o;
		return this.targa().equals(m.targa()) && this.casaProduttrice().equals(m.casaProduttrice()) && this.modello().equals(m.modello()) && this.prezzo().equals(m.prezzo());
	}
	
}
