package net.alviano.safe;

import static org.apache.commons.lang3.Validate.notBlank;
import static org.apache.commons.lang3.Validate.inclusiveBetween;
import static org.apache.commons.lang3.Validate.matchesPattern;

public final class Targa {
	private final String value;
	
	public Targa(String value) {
		this.value = notBlank(value);
		inclusiveBetween(5, 10, value.length());
		matchesPattern(value, "[0-9A-Z]*");
		// altra validazione sui formati ammessibili per le targhe
	}
	
	public String value() {
		return this.value;
	}
	
	@Override
	public String toString() {
		return value;
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != Targa.class) return false;
		Targa t = (Targa) o;
		return this.value.equals(t.value);
	}
}
